(*
 *  beware IRC services, bworldjupe.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)
unit bworldjupe;

interface


uses buser,bcmds,bstuff,blinklist,bpremaskmatch;
(*
const
  glineflag_active=   $1;
  glineflag_local=    $2;
  glineflag_badchan=  $4;
  glineflag_ipmask=   $8;

procedure cleargline;

procedure loadjupe(filename:string);
*)

type
  tjupe=class(tlinklist)
    sender:string;
    name:string;
    numeric:integer;
    reason:string;
  end;

var
  jupelist:tlinklist;

procedure savejupe(const filename:string);
procedure clearjupe;

{
JUPE procedures:

- load, load from file, send SQ and S messages to apply only changes

- save

- find (exact name)

- add (by command) function, returns success, failure

- delete (by command)


}

implementation

uses btime,bchannel,bparse,bconfig;

procedure savejupe(const filename:string);
var
  t:textfile;
  gl:tjupe;

procedure writejupe;
begin
  writeln(t,'[jupe]');
  writeln(t,'name=',gl.name);
  writeln(t,'numeric=',inttostr(gl.numeric));
  writeln(t,'sender=',gl.sender);
  writeln(t,'reason=',gl.reason);
  writeln(t);
end;

begin
  assignfile(t,filename);
  filemode := 2;
  {$i-}rewrite(t);{$i+}
  if ioresult <> 0 then begin
    {saving jupes failed}
    exit;
  end;
  gl := tjupe(jupelist);
  while gl <> nil do begin
    writejupe;
    gl := tjupe(gl.next);
  end;
  closefile(t);
end;

procedure clearjupe;
var
  gl,gl2:tjupe;
begin
  gl := tjupe(jupelist);
  while gl <> nil do begin
    gl2 := tjupe(gl.next);
    linklistdel(jupelist,tlinklist(gl));
    gl.destroy;
    gl := gl2;
  end;
end;

begin
  jupelist := nil;
end.
