(*
 *  beware IRC services, passcryp.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

{$g+,n-,e-,r-,s-,q-,d-,l-,y-,x+}
// interface unit to password crypt engines
// if the number of engines grows i may move this to a table based system

unit passcryp;

interface


function passmatch(const pass,crypted:string):boolean;
function passnewcrypt(const pass:string):string;
function iscryptedlength(passlength : integer):boolean;

implementation
uses bircmd5pass,bircoldpass;


// note useing result would make this code much sipler but would break tpc
// which is used to compile release versions of mkpasswd to keep the size down
function passmatch(const pass,crypted:string):boolean;

begin
  passmatch := bircmd5pass.passmatch(pass,crypted) or bircoldpass.passmatch(pass,crypted);

end;



function passnewcrypt(const pass:string):string;
begin
 passnewcrypt := bircmd5pass.passnewcrypt(pass);
end;
function iscryptedlength(passlength : integer):boolean;
begin
  iscryptedlength := (passlength=bircmd5pass.cryptedpasslen) or (passlength=bircoldpass.cryptedpasslen)
end;

end.
